Properties Methods Events Config Options Direct Link

    Observable
      Component
        BoxComponent
          Container
            Viewport

# Class Ext.Viewport

Package: | Ext
Defined In: | Viewport.js
Class: | Viewport
Extends: | Container

A specialized container representing the viewable application area (the browser viewport).

The Viewport renders itself to the document body, and automatically sizes itself to the size of the browser viewport and manages window resizing. There may only be one Viewport created in a page. Inner layouts are available by virtue of the fact that all Panels added to the Viewport, either through its items, or through the items, or the add method of any of its child Panels may themselves have a layout.

The Viewport does not provide scrolling, so child Panels within the Viewport should provide for scrolling if needed using the autoScroll config.

Example showing a classic application border layout :

#

    new Ext.Viewport({
        layout: 'border',
        defaults: {
            activeItem: 0,
        },
        items: [{
            region: 'north',
            html: 'Page Title',
            autoHeight: true,
            border: false,
            margins: '0 0 5 0'
        }, {
            region: 'west',
            collapsible: true,
            title: 'Navigation',
            xtype: 'treepanel',
            width: 200,
            autoScroll: true,
            split: true,
            loader: new Ext.tree.TreeLoader(),
            root: new Ext.tree.AsyncTreeNode({
                expanded: true,
                children: [{
                    text: 'Menu Option 1',
                    leaf: true
                }, {
                    text: 'Menu Option 2',
                    leaf: true
                }, {
                    text: 'Menu Option 3',
                    leaf: true
                }]
            }),
            rootVisible: false,
            listeners: {
                click: function(n) {
                    Ext.Msg.alert('Navigation Tree Click', 'You clicked: "' + n.attributes.text + '"');
                }
            }
        }, {
            region: 'center',
            xtype: 'tabpanel',
            items: {
                title: 'Default Tab',
                html: 'The first tab\'s content. Others may be added dynamically'
            }
        }, {
            region: 'south',
            title: 'Information',
            collapsible: true,
            html: 'Information goes here',
            split: true,
            height: 100,
            minHeight: 100
        }]
    });

## Config Options

Config Options | Defined By
--- | ---

activeItem : String/Number
A string component id or the numeric index of the component that should be initially activated within the container's...
A string component id or the numeric index of the component that should be initially activated within the container's layout on render. For example, activeItem: 'item-1' or activeItem: 0 (index 0 = the first item in the container's collection). activeItem only applies to layout styles that can display items one at a time (like Ext.layout.Accordion, Ext.layout.CardLayout and Ext.layout.FitLayout). Related to Ext.layout.ContainerLayout.activeItem.

Container

| autoDestroy : Boolean If true the container will automatically destroy any contained component that is removed from it, else destruction mu... If true the container will automatically destroy any contained component that is removed from it, else destruction must be handled manually (defaults to true). | Container
| autoShow : Boolean True if the component should check for hidden classes (e.g. 'x-hidden' or 'x-hide-display') and remove them on render... True if the component should check for hidden classes (e.g. 'x-hidden' or 'x-hide-display') and remove them on render (defaults to false). | Component

bufferResize : Boolean/Number
When set to true (100 milliseconds) or a number of milliseconds, the layout assigned for this container will buffer t...
When set to true (100 milliseconds) or a number of milliseconds, the layout assigned for this container will buffer the frequency it calculates and does a re-layout of components. This is useful for heavy containers or containers with a large amount of sub components that frequent calls to layout are expensive.

Container

| cls : String An optional extra CSS class that will be added to this component's Element (defaults to ''). This can be useful for a... An optional extra CSS class that will be added to this component's Element (defaults to ''). This can be useful for adding customized styles to the component or any of its children using standard CSS rules. | Component
| ctCls : String An optional extra CSS class that will be added to this component's container (defaults to ''). This can be useful for... An optional extra CSS class that will be added to this component's container (defaults to ''). This can be useful for adding customized styles to the container or any of its children using standard CSS rules. | Component
| defaultType : String The default type of container represented by this object as registered in Ext.ComponentMgr (defaults to 'panel'). | Container

defaults : Object
A config object that will be applied to all components added to this container either via the items config or via the...
A config object that will be applied to all components added to this container either via the items config or via the add or insert methods. The defaults config can contain any number of name/value property pairs to be added to each item, and should be valid for the types of items being added to the container. For example, to automatically apply padding to the body of each of a set of contained Ext.Panel items, you could pass: defaults: {bodyStyle:'padding:15px'}.

Container

| disabledClass : String CSS class added to the component when it is disabled (defaults to "x-item-disabled"). | Component
| hideBorders : Boolean True to hide the borders of each contained component, false to defer to the component's existing border settings (def... True to hide the borders of each contained component, false to defer to the component's existing border settings (defaults to false). | Container
| hideMode : String How this component should hidden. Supported values are "visibility" (css visibility), "offsets" (negative offset posi... How this component should hidden. Supported values are "visibility" (css visibility), "offsets" (negative offset position) and "display" (css display) - defaults to "display". | Component
| id : String The unique id of this component (defaults to an auto-assigned id). | Component

items : Mixed
A single item, or an array of child Components to be added to this container. Each item can be any type of object bas...
A single item, or an array of child Components to be added to this container. Each item can be any type of object based on Ext.Component.
Component config objects may also be specified in order to avoid the overhead of constructing a real Component object if lazy rendering might mean that the added Component will not be rendered immediately. To take advantage of this "lazy instantiation", set the Ext.Component.xtype config property to the registered type of the Component wanted.
For a list of all available xtypes, see Ext.Component. If a single item is being passed, it should be passed directly as an object reference (e.g., items: {...}). Multiple items should be passed as an array of objects (e.g., items: [{...}, {...}]).

Container

layout : String
The layout type to be used in this container. If not specified, a default Ext.layout.ContainerLayout will be created ...
The layout type to be used in this container. If not specified, a default Ext.layout.ContainerLayout will be created and used. Valid values are: accordion, anchor, border, card, column, fit, form and table. Specific config values for the chosen layout type can be specified using layoutConfig.

Container

layoutConfig : Object
This is a config object containing properties specific to the chosen layout (to be used in conjunction with the layou...
This is a config object containing properties specific to the chosen layout (to be used in conjunction with the layout config value). For complete details regarding the valid config options for each layout type, see the layout class corresponding to the type specified:

- Ext.layout.Accordion
- Ext.layout.AnchorLayout
- Ext.layout.BorderLayout
- Ext.layout.CardLayout
- Ext.layout.ColumnLayout
- Ext.layout.FitLayout
- Ext.layout.FormLayout
- Ext.layout.TableLayout

Container

| listeners : Object A config object containing one or more event handlers to be added to this object during initialization. This should b... A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once. | Observable
| monitorResize : Boolean True to automatically monitor window resize events to handle anything that is sensitive to the current size of the vi... True to automatically monitor window resize events to handle anything that is sensitive to the current size of the viewport. This value is typically managed by the chosen layout and should not need to be set manually. | Container

plugins : Object/Array
An object or array of objects that will provide custom functionality for this component. The only requirement for a v...
An object or array of objects that will provide custom functionality for this component. The only requirement for a valid plugin is that it contain an init method that accepts a reference of type Ext.Component. When a component is created, if any plugins are available, the component will call the init method on each plugin, passing a reference to itself. Each plugin can then call methods or respond to events on the component as needed to provide its functionality.

Component

| stateEvents : Array An array of events that, when fired, should trigger this component to save its state (defaults to none). These can be... An array of events that, when fired, should trigger this component to save its state (defaults to none). These can be any types of events supported by this component, including browser or custom events (e.g., ['click', 'customerchange']). | Component
| stateId : String The unique id for this component to use for state management purposes (defaults to the component id). | Component
| style : String A custom style specification to be applied to this component's Element. Should be a valid argument to Ext.Element.app... A custom style specification to be applied to this component's Element. Should be a valid argument to Ext.Element.applyStyles. | Component

xtype : String
The registered xtype to create. This config option is not used when passing a config object into a constructor. This ...
The registered xtype to create. This config option is not used when passing a config object into a constructor. This config option is used only when lazy instantiation is being used, and a child item of a Container is being specified not as a fully instantiated Component, but as a Component config object. The xtype will be looked up at render time up to determine what type of child Component to create.
The predefined xtypes are listed here.
If you subclass Components to create your own Components, you may register them using Ext.ComponentMgr.registerType in order to be able to take advantage of lazy instantiation and rendering.

Component

## Public Properties

Property | Defined By
--- | ---
| disabled : Boolean True if this component is disabled. Read-only. | Component
| hidden : Boolean True if this component is hidden. Read-only. | Component
| initialConfig : Object This Component's initial configuration specification. Read-only. | Component
| items : MixedCollection The collection of components in this container as a Ext.util.MixedCollection | Container
| ownerCt : Ext.Container The component's owner Ext.Container (defaults to undefined, and is set automatically when the component is added to a... The component's owner Ext.Container (defaults to undefined, and is set automatically when the component is added to a container). Read-only. | Component
| rendered : Boolean True if this component has been rendered. Read-only. | Component

## Public Methods

Method | Defined By
--- | ---

Viewport( `Object config` )
Create a new Viewport
Create a new Viewport
Parameters:

- `config` : Object
  The config object

Returns:

- ``

Viewport

add( `Ext.Component/Object component` ) : Ext.Component
Adds a Component to this Container. Fires the beforeadd event before adding, then fires the add event after the compo...
Adds a Component to this Container. Fires the beforeadd event before adding, then fires the add event after the component has been added.
Parameters:

- `component` : Ext.Component/Object
  The component to add.
  Ext uses lazy rendering, and will only render the added Component should it become necessary.
  A Component config object may be passed in order to avoid the overhead of constructing a real Component object if lazy rendering might mean that the added Component will not be rendered immediately. To take advantage of this "lazy instantiation", set the Ext.Component.xtype config property to the registered type of the Component wanted.
  For a list of all available xtypes, see Ext.Component.

Returns:

- `Ext.Component`
  component The Component (or config object) that was added with the Container's default config values applied.

Container

addClass( `string cls` ) : void
Adds a CSS class to the component's underlying element.
Adds a CSS class to the component's underlying element.
Parameters:

- `cls` : string
  The CSS class name to add

Returns:

- `void`

Component

addEvents( `Object object` ) : void
Used to define events on this Observable
Used to define events on this Observable
Parameters:

- `object` : Object
  The object with the events defined

Returns:

- `void`

Observable

addListener( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this component
Appends an event handler to this component
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional) An object containing handler configuration properties. This may contain any of the following properties:
  - scope : Object

    The scope in which to execute the handler function. The handler function's "this" context.

  - delay : Number

    The number of milliseconds to delay the invocation of the handler after the event fires.

  - single : Boolean

    True to add a handler to handle just the next firing of the event, and then remove itself.

  - buffer {Number} Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A normalized, delayed, one-time listener that auto stops the event and passes a custom argument (forumId)

      el.on('click', this.onClick, this, {
          single: true,
          delay: 100,
          forumId: 4
      });

  Attaching multiple handlers in 1 call
  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

      foo.on({
          'click' : {
              fn: this.onClick,
              scope: this,
              delay: 100
          },
          'mouseover' : {
              fn: this.onMouseOver,
              scope: this
          },
          'mouseout' : {
              fn: this.onMouseOut,
              scope: this
          }
      });

  Or a shorthand syntax:

      foo.on({
          'click' : this.onClick,
          'mouseover' : this.onMouseOver,
          'mouseout' : this.onMouseOut,
           scope: this
      });

Returns:

- `void`

Observable

applyToMarkup( `String/HTMLElement el` ) : void
Apply this component to existing markup that is valid. With this function, no call to render() is required.
Apply this component to existing markup that is valid. With this function, no call to render() is required.
Parameters:

- `el` : String/HTMLElement

Returns:

- `void`

Component

bubble( `Function fn`, [`Object scope`], [`Array args`] ) : void
Bubbles up the component/container heirarchy, calling the specified function with each component. The scope (this) of...
Bubbles up the component/container heirarchy, calling the specified function with each component. The scope (this) of function call will be the scope provided or the current component. The arguments to the function will be the args provided or the current component. If the function returns false at any point, the bubble is stopped.
Parameters:

- `fn` : Function
  The function to call
- `scope` : Object
  (optional) The scope of the function (defaults to current node)
- `args` : Array
  (optional) The args to call the function with (default to passing the current component)

Returns:

- `void`

Container

cascade( `Function fn`, [`Object scope`], [`Array args`] ) : void
Cascades down the component/container heirarchy from this component (called first), calling the specified function wi...
Cascades down the component/container heirarchy from this component (called first), calling the specified function with each component. The scope (this) of function call will be the scope provided or the current component. The arguments to the function will be the args provided or the current component. If the function returns false at any point, the cascade is stopped on that branch.
Parameters:

- `fn` : Function
  The function to call
- `scope` : Object
  (optional) The scope of the function (defaults to current component)
- `args` : Array
  (optional) The args to call the function with (defaults to passing the current component)

Returns:

- `void`

Container

cloneConfig( `Object overrides` ) : Ext.Component
Clone the current component using the original config values passed into this instance by default.
Clone the current component using the original config values passed into this instance by default.
Parameters:

- `overrides` : Object
  A new config containing any properties to override in the cloned version. An id property can be passed on this object, otherwise one will be generated to avoid duplicates.

Returns:

- `Ext.Component`
  clone The cloned copy of this component

Component

destroy() : void
Destroys this component by purging any event listeners, removing the component's element from the DOM, removing the c...
Destroys this component by purging any event listeners, removing the component's element from the DOM, removing the component from its Ext.Container (if applicable) and unregistering it from Ext.ComponentMgr. Destruction is generally handled automatically by the framework and this method should usually not need to be called directly.
Parameters:

- None.

Returns:

- `void`

Component

disable() : Ext.Component
Disable this component.
Disable this component.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

doLayout() : void
Force this container's layout to be recalculated. A call to this function is required after adding a new component to...
Force this container's layout to be recalculated. A call to this function is required after adding a new component to an already rendered container. If you are not dynamically adding and removing components after render, this function will generally not need to be called.
Parameters:

- None.

Returns:

- `void`

Container

enable() : Ext.Component
Enable this component.
Enable this component.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

find( `String prop`, `String value` ) : Array
Find a component under this container at any level by property
Find a component under this container at any level by property
Parameters:

- `prop` : String
- `value` : String

Returns:

- `Array`
  Array of Ext.Components

Container

findBy( `Function fcn`, [`Object scope`] ) : Array
Find a component under this container at any level by a custom function. If the passed function returns true, the com...
Find a component under this container at any level by a custom function. If the passed function returns true, the component will be included in the results. The passed function is called with the arguments (component, this container).
Parameters:

- `fcn` : Function
- `scope` : Object
  (optional)

Returns:

- `Array`
  Array of Ext.Components

Container

findById( `String id` ) : Ext.Component
Find a component under this container at any level by id
Find a component under this container at any level by id
Parameters:

- `id` : String

Returns:

- `Ext.Component`

Container

findByType( `String/Class xtype` ) : Array
Find a component under this container at any level by xtype or class
Find a component under this container at any level by xtype or class
Parameters:

- `xtype` : String/Class
  The xtype string for a component, or the class of the component directly

Returns:

- `Array`
  Array of Ext.Components

Container

fireEvent( `String eventName`, `Object... args` ) : Boolean
Fires the specified event with the passed parameters (minus the event name).
Fires the specified event with the passed parameters (minus the event name).
Parameters:

- `eventName` : String
- `args` : Object...
  Variable number of parameters are passed to handlers

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true

Observable

focus( [`Boolean selectText`], [`Boolean/Number delay`] ) : Ext.Component
Try to focus this component.
Try to focus this component.
Parameters:

- `selectText` : Boolean
  (optional) If applicable, true to also select the text in this component
- `delay` : Boolean/Number
  (optional) Delay the focus this number of milliseconds (true for 10 milliseconds)

Returns:

- `Ext.Component`
  this

Component

getBox( [`Boolean local`] ) : Object
Gets the current box measurements of the component's underlying element.
Gets the current box measurements of the component's underlying element.
Parameters:

- `local` : Boolean
  (optional) If true the element's left and top are returned instead of page XY (defaults to false)

Returns:

- `Object`
  box An object in the format {x, y, width, height}

BoxComponent

getComponent( `String/Number id` ) : Ext.Component
Gets a direct child Component by id, or by index.
Gets a direct child Component by id, or by index.
Parameters:

- `id` : String/Number
  or index of child Component to return.

Returns:

- `Ext.Component`

Container

getEl() : Ext.Element
Returns the underlying Ext.Element.
Returns the underlying Ext.Element.
Parameters:

- None.

Returns:

- `Ext.Element`
  The element

Component

getId() : String
Returns the id of this component.
Returns the id of this component.
Parameters:

- None.

Returns:

- `String`

Component

getItemId() : String
Returns the item id of this component.
Returns the item id of this component.
Parameters:

- None.

Returns:

- `String`

Component

getLayout() : ContainerLayout
Returns the layout currently in use by the container. If the container does not currently have a layout set, a defau...
Returns the layout currently in use by the container. If the container does not currently have a layout set, a default Ext.layout.ContainerLayout will be created and set as the container's layout.
Parameters:

- None.

Returns:

- `ContainerLayout`
  layout The container's layout

Container

getPosition( [`Boolean local`] ) : Array
Gets the current XY position of the component's underlying element.
Gets the current XY position of the component's underlying element.
Parameters:

- `local` : Boolean
  (optional) If true the element's left and top are returned instead of page XY (defaults to false)

Returns:

- `Array`
  The XY position of the element (e.g., [100, 200])

BoxComponent

getSize() : Object
Gets the current size of the component's underlying element.
Gets the current size of the component's underlying element.
Parameters:

- None.

Returns:

- `Object`
  An object containing the element's size {width: (element width), height: (element height)}

BoxComponent

getXType() : String
Gets the xtype for this component as registered with Ext.ComponentMgr. For a list of all available xtypes, see the Ex...
Gets the xtype for this component as registered with Ext.ComponentMgr. For a list of all available xtypes, see the Ext.Component header. Example usage:

    var t = new Ext.form.TextField();
    alert(t.getXType());  // alerts 'textfield'

Parameters:

- None.

Returns:

- `String`
  The xtype

Component

getXTypes() : String
Returns this component's xtype hierarchy as a slash-delimited string. For a list of all available xtypes, see the Ext...
Returns this component's xtype hierarchy as a slash-delimited string. For a list of all available xtypes, see the Ext.Component header. Example usage:

    var t = new Ext.form.TextField();
    alert(t.getXTypes());  // alerts 'component/box/field/textfield'

Parameters:

- None.

Returns:

- `String`
  The xtype hierarchy string

Component

hasListener( `String eventName` ) : Boolean
Checks to see if this object has any listeners for a specified event
Checks to see if this object has any listeners for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

Observable

hide() : Ext.Component
Hide this component.
Hide this component.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

insert( `Number index`, `Ext.Component component` ) : Ext.Component
Inserts a Component into this Container at a specified index. Fires the beforeadd event before inserting, then fires ...
Inserts a Component into this Container at a specified index. Fires the beforeadd event before inserting, then fires the add event after the Component has been inserted.
Parameters:

- `index` : Number
  The index at which the Component will be inserted into the Container's items collection
- `component` : Ext.Component
  The child Component to insert.
  Ext uses lazy rendering, and will only render the inserted Component should it become necessary.
  A Component config object may be passed in order to avoid the overhead of constructing a real Component object if lazy rendering might mean that the inserted Component will not be rendered immediately. To take advantage of this "lazy instantiation", set the Ext.Component.xtype config property to the registered type of the Component wanted.
  For a list of all available xtypes, see Ext.Component.

Returns:

- `Ext.Component`
  component The Component (or config object) that was inserted with the Container's default config values applied.

Container

isVisible() : void
Returns true if this component is visible.
Returns true if this component is visible.
Parameters:

- None.

Returns:

- `void`

Component

isXType( `String xtype`, [`Boolean shallow`] ) : void
Tests whether or not this component is of a specific xtype. This can test whether this component is descended from th...
Tests whether or not this component is of a specific xtype. This can test whether this component is descended from the xtype (default) or whether it is directly of the xtype specified (shallow = true). For a list of all available xtypes, see the Ext.Component header. Example usage:

    var t = new Ext.form.TextField();
    var isText = t.isXType('textfield');        // true
    var isBoxSubclass = t.isXType('box');       // true, descended from BoxComponent
    var isBoxInstance = t.isXType('box', true); // false, not a direct BoxComponent instance

Parameters:

- `xtype` : String
  The xtype to check for this component
- `shallow` : Boolean
  (optional) False to check whether this component is descended from the xtype (this is the default), or true to check whether this component is directly of the specified xtype.

Returns:

- `void`

Component

on( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this element (shorthand for addListener)
Appends an event handler to this element (shorthand for addListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional)

Returns:

- `void`

Observable

purgeListeners() : void
Removes all listeners for this object
Removes all listeners for this object
Parameters:

- None.

Returns:

- `void`

Observable

remove( `Component/String component`, [`Boolean autoDestroy`] ) : void
Removes a component from this container. Fires the beforeremove event before removing, then fires the remove event a...
Removes a component from this container. Fires the beforeremove event before removing, then fires the remove event after the component has been removed.
Parameters:

- `component` : Component/String
  The component reference or id to remove
- `autoDestroy` : Boolean
  (optional) True to automatically invoke the component's Ext.Component.destroy function

Returns:

- `void`

Container

removeClass( `string cls` ) : void
Removes a CSS class from the component's underlying element.
Removes a CSS class from the component's underlying element.
Parameters:

- `cls` : string
  The CSS class name to remove

Returns:

- `void`

Component

removeListener( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes a listener
Removes a listener
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

Observable

render( [`Mixed container`], [`String/Number position`] ) : void
If this is a lazy rendering component, render it to its container element.
If this is a lazy rendering component, render it to its container element.
Parameters:

- `container` : Mixed
  (optional) The element this component should be rendered into. If it is being applied to existing markup, this should be left off.
- `position` : String/Number
  (optional) The element ID or DOM node index within the container before which this component will be inserted (defaults to appending to the end of the container)

Returns:

- `void`

Component

resumeEvents() : void
Resume firing events. (see suspendEvents)
Resume firing events. (see suspendEvents)
Parameters:

- None.

Returns:

- `void`

Observable

setDisabled( `Boolean disabled` ) : void
Convenience function for setting disabled/enabled by boolean.
Convenience function for setting disabled/enabled by boolean.
Parameters:

- `disabled` : Boolean

Returns:

- `void`

Component

setHeight( `Number height` ) : Ext.BoxComponent
Sets the height of the component. This method fires the resize event.
Sets the height of the component. This method fires the resize event.
Parameters:

- `height` : Number
  The new height to set

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

setPagePosition( `Number x`, `Number y` ) : Ext.BoxComponent
Sets the page XY position of the component. To set the left and top instead, use setPosition. This method fires the ...
Sets the page XY position of the component. To set the left and top instead, use setPosition. This method fires the move event.
Parameters:

- `x` : Number
  The new x position
- `y` : Number
  The new y position

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

setPosition( `Number left`, `Number top` ) : Ext.BoxComponent
Sets the left and top of the component. To set the page XY position instead, use setPagePosition. This method fires ...
Sets the left and top of the component. To set the page XY position instead, use setPagePosition. This method fires the move event.
Parameters:

- `left` : Number
  The new left
- `top` : Number
  The new top

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

setSize( `Number/Object width`, `Number height` ) : Ext.BoxComponent
Sets the width and height of the component. This method fires the resize event. This method can accept either width...
Sets the width and height of the component. This method fires the resize event. This method can accept either width and height as separate numeric arguments, or you can pass a size object like {width:10, height:20}.
Parameters:

- `width` : Number/Object
  The new width to set, or a size object in the format {width, height}
- `height` : Number
  The new height to set (not required if a size object is passed as the first arg)

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

setVisible( `Boolean visible` ) : Ext.Component
Convenience function to hide or show this component by boolean.
Convenience function to hide or show this component by boolean.
Parameters:

- `visible` : Boolean
  True to show, false to hide

Returns:

- `Ext.Component`
  this

Component

setWidth( `Number width` ) : Ext.BoxComponent
Sets the width of the component. This method fires the resize event.
Sets the width of the component. This method fires the resize event.
Parameters:

- `width` : Number
  The new width to set

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

show() : Ext.Component
Show this component.
Show this component.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

suspendEvents() : void
Suspend the firing of all events. (see resumeEvents)
Suspend the firing of all events. (see resumeEvents)
Parameters:

- None.

Returns:

- `void`

Observable

syncSize() : Ext.BoxComponent
Force the component's size to recalculate based on the underlying element's current height and width.
Force the component's size to recalculate based on the underlying element's current height and width.
Parameters:

- None.

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

un( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes a listener (shorthand for removeListener)
Removes a listener (shorthand for removeListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

Observable

updateBox( `Object box` ) : Ext.BoxComponent
Sets the current box measurements of the component's underlying element.
Sets the current box measurements of the component's underlying element.
Parameters:

- `box` : Object
  An object in the format {x, y, width, height}

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

## Public Events

Event | Defined By
--- | ---

add : ( `Ext.Container this`, `Ext.Component component`, `Number index` )
Fires after any Ext.Component is added or inserted into the container.
Fires after any Ext.Component is added or inserted into the container.
Listeners will be called with the following arguments:

- `this` : Ext.Container
- `component` : Ext.Component
  The component that was added
- `index` : Number
  The index at which the component was added to the container's items collection

Container

afterlayout : ( `Ext.Container this`, `ContainerLayout layout` )
Fires when the components in this container are arranged by the associated layout manager.
Fires when the components in this container are arranged by the associated layout manager.
Listeners will be called with the following arguments:

- `this` : Ext.Container
- `layout` : ContainerLayout
  The ContainerLayout implementation for this container

Container

beforeadd : ( `Ext.Container this`, `Ext.Component component`, `Number index` )
Fires before any Ext.Component is added or inserted into the container. A handler can return false to cancel the add.
Fires before any Ext.Component is added or inserted into the container. A handler can return false to cancel the add.
Listeners will be called with the following arguments:

- `this` : Ext.Container
- `component` : Ext.Component
  The component being added
- `index` : Number
  The index at which the component will be added to the container's items collection

Container

beforedestroy : ( `Ext.Component this` )
Fires before the component is destroyed. Return false to stop the destroy.
Fires before the component is destroyed. Return false to stop the destroy.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforehide : ( `Ext.Component this` )
Fires before the component is hidden. Return false to stop the hide.
Fires before the component is hidden. Return false to stop the hide.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforeremove : ( `Ext.Container this`, `Ext.Component component` )
Fires before any Ext.Component is removed from the container. A handler can return false to cancel the remove.
Fires before any Ext.Component is removed from the container. A handler can return false to cancel the remove.
Listeners will be called with the following arguments:

- `this` : Ext.Container
- `component` : Ext.Component
  The component being removed

Container

beforerender : ( `Ext.Component this` )
Fires before the component is rendered. Return false to stop the render.
Fires before the component is rendered. Return false to stop the render.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforeshow : ( `Ext.Component this` )
Fires before the component is shown. Return false to stop the show.
Fires before the component is shown. Return false to stop the show.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforestaterestore : ( `Ext.Component this`, `Object state` )
Fires before the state of the component is restored. Return false to stop the restore.
Fires before the state of the component is restored. Return false to stop the restore.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values

Component

beforestatesave : ( `Ext.Component this`, `Object state` )
Fires before the state of the component is saved to the configured state provider. Return false to stop the save.
Fires before the state of the component is saved to the configured state provider. Return false to stop the save.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values

Component

destroy : ( `Ext.Component this` )
Fires after the component is destroyed.
Fires after the component is destroyed.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

disable : ( `Ext.Component this` )
Fires after the component is disabled.
Fires after the component is disabled.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

enable : ( `Ext.Component this` )
Fires after the component is enabled.
Fires after the component is enabled.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

hide : ( `Ext.Component this` )
Fires after the component is hidden.
Fires after the component is hidden.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

move : ( `Ext.Component this`, `Number x`, `Number y` )
Fires after the component is moved.
Fires after the component is moved.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `x` : Number
  The new x position
- `y` : Number
  The new y position

BoxComponent

remove : ( `Ext.Container this`, `Ext.Component component` )
Fires after any Ext.Component is removed from the container.
Fires after any Ext.Component is removed from the container.
Listeners will be called with the following arguments:

- `this` : Ext.Container
- `component` : Ext.Component
  The component that was removed

Container

render : ( `Ext.Component this` )
Fires after the component is rendered.
Fires after the component is rendered.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

resize : ( `Ext.Component this`, `Number adjWidth`, `Number adjHeight`, `Number rawWidth`, `Number rawHeight` )
Fires after the component is resized.
Fires after the component is resized.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `adjWidth` : Number
  The box-adjusted width that was set
- `adjHeight` : Number
  The box-adjusted height that was set
- `rawWidth` : Number
  The width that was originally specified
- `rawHeight` : Number
  The height that was originally specified

BoxComponent

show : ( `Ext.Component this` )
Fires after the component is shown.
Fires after the component is shown.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

staterestore : ( `Ext.Component this`, `Object state` )
Fires after the state of the component is restored.
Fires after the state of the component is restored.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values

Component

statesave : ( `Ext.Component this`, `Object state` )
Fires after the state of the component is saved to the configured state provider.
Fires after the state of the component is saved to the configured state provider.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values

Component